/*******************************************************
**  V0.0 Crop Image                                   **
**              ---- March 1999.                      **
*******************************************************/

/******************************
 To compile:
  gcc cropImage.c imageFile-io.V2.0.o utils.o -o cropImage
*******************************/

# include "imageFile-io.h"
# include "utils.h"
# include "macros.h"

char pathNameOutput[MAXLEN], outputFileRoot[MAXLEN];

main()
 {

  char fileType[MAXLEN], fnInput[MAXLEN];
  char fnOutput[MAXLEN], scrName[MAXLEN];
  int pgmInput, nHead, nxImage, nyImage, nxCrop, nyCrop;
  int ix0, iy0, ix1, iy1, ix, iy;
  unsigned char *image, *scrImage;
  unsigned char *cImage[3];
  FILE *fpInput;
  
  /**************/
  /* Read image */
  /**************/
  fprintf(stderr, "image file type (pgm or raw) and  filename");
  scanf("%s %s", fileType, fnInput);
  /* Open image file */
  if ((fpInput = fopenInputFile(fnInput)) == NULL) 
    error("Can't open image file",fnInput);

  if (strcmp(fileType, "pgm") == 0) {
   read_pgm_image(&image, fpInput, fnInput, &nxImage, &nyImage);
  } else if (strcmp(fileType, "raw") == 0) {
    fprintf(stderr, "input image size: nHeader, nx, ny :");
    scanf("%d %d %d", &nHead, &nxImage, &nyImage);
    grabByteMemory((char **) (&image), nxImage * nyImage, fnInput);
    read_byte_image_strip_bytes(image, fpInput, fnInput,
              nxImage, nyImage, nHead);
    fclose(fpInput);
  } else {
    error("Unrecognized file type for",fnInput);
  }

  /******** Read output file names ********/
  fprintf(stderr," enter output path and rootName : ");
  scanf("%s %s", pathNameOutput, outputFileRoot);
  if (checkForNull(pathNameOutput) == 0)
    pathNameOutput[0] = 0;
  if (checkForNull(outputFileRoot) == 0) {
    outputFileRoot[0] = 0;
    fprintf(stderr, " outputFileRoot = NULL, do not dump merged results\n");
  }

  /***************** Parameter input ***************/
  fprintf(stderr," enter coords for top-left and bottom-right corners : ");
  scanf("%d %d %d %d", &ix0, &iy0, &ix1, &iy1);

  if ( ix0 < 0 || ix0 > nxImage || iy0 < 0 || iy0 > nxImage )
   error("Invalid top left corner","");
  if ( ix1 < 1 || ix1 > nxImage || iy1 < 1 || iy1 > nxImage )
   error("Invalid top right corner","");
  if ( ix1 <= ix0 || iy1 <= iy0 )
   error("Null cropping region","");

  /**** Make Cropped image ****/
  nxCrop = ix1 - ix0;
  nyCrop = iy1 - iy0;
  grabByteMemory((char **) &scrImage, nxCrop * nyCrop, "scrImage");
  for(iy=0; iy<nyCrop; iy++)
   for(ix=0; ix<nxCrop; ix++) 
    scrImage[index(ix,iy, nxCrop)] = image[index(ix+ix0,iy+iy0,nxImage)];

  /* Dump cropped image */
  strcpy(fnOutput, pathNameOutput);
  strcat(fnOutput, outputFileRoot);
  save_pgm_image(fnOutput, scrImage, nxCrop, nyCrop);
  free(scrImage);
  free(image);

}
