
/******************************
 To compile:
  gcc -I .. byteOrder.c ../imageFile-io.V2.0.c ../utils.c -o byteOrder
*******************************/

# include "macros.h"
# include "utils.h"
# include "imageFile-io.h"

main()
{
  fprintf(stderr, "BYTE_ORDER_TYPE = %c\n", getByteOrderType());

  fprintf(stderr, "isBigEndian = %d\n", isBigEndian());
}

int isBigEndian()
{
  union
  {
    unsigned long xlong ;
    unsigned char xchar[sizeof(unsigned long)];
  } testVal ;

  // create an MSB of 0x80 and an LSB of 0x00
  // Assumptions: bytes have 8 bits
  testVal.xlong = 1 << (sizeof(unsigned long) * 8 -1);
  // for Big-Endian, 0x80 should be in first byte
  if ( testVal.xchar[0] == 0x80 )
   return(TRUE);
  else
   return(FALSE);
}

